/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.DateValidate
 */
package fire.pb.battle.pvp;

import fire.pb.battle.pvp.EPvPStage;
import fire.pb.battle.pvp.IPvPStage;
import fire.pb.battle.pvp.PvPControl;
import fire.pb.talk.MessageMgr;
import fire.pb.util.DateValidate;
import java.util.Calendar;

public class PvPStageCommon {

    public static class Award
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.AWARD;
        }

        @Override
        public void onEnter(PvPControl c) {
            long delay = this.getDelayTime();
            c.createSchedule(0L, delay /= 1000L);
        }

        @Override
        public void onLeave(PvPControl c) {
            c.close();
        }

        @Override
        public void onTick(PvPControl c) {
            c.removeSchedule();
            c.removeNpc();
            c.changeStage(EPvPStage.NOTOPEN);
        }

        @Override
        public boolean onApplyEnter(PvPControl c, long roleId, int gotoType) {
            MessageMgr.sendMsgNotify((long)roleId, (int)160348, null);
            return true;
        }

        public long getDelayTime() {
            long now = System.currentTimeMillis();
            Calendar lastSecondCalendar = DateValidate.getLastSecondCalendar();
            long delay = lastSecondCalendar.getTimeInMillis() - now;
            return delay;
        }
    }

    public static class End
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.END;
        }

        @Override
        public void onEnter(PvPControl c) {
            c.changeStage(EPvPStage.AWARD);
        }

        @Override
        public void onLeave(PvPControl c) {
        }
    }

    public static class Fight
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.FIGHT;
        }

        @Override
        public void onEnter(PvPControl c) {
            c.createSchedule(5L, 0L);
        }

        @Override
        public void onLeave(PvPControl c) {
        }

        @Override
        public void onTick(PvPControl c) {
        }

        @Override
        public boolean onApplyEnter(PvPControl c, long roleId, int gotoType) {
            return c.doApplyEnter(roleId, gotoType);
        }

        @Override
        public void onApplyLeave(PvPControl c, long roleId) {
            c.doApplyLeave(roleId);
        }
    }

    public static class Prepare
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.PREPARE;
        }

        @Override
        public void onEnter(PvPControl c) {
            c.createSchedule(1L, 0L);
        }

        @Override
        public void onLeave(PvPControl c) {
        }

        @Override
        public void onTick(PvPControl c) {
            if (c.isFightTime()) {
                c.changeStage(EPvPStage.FIGHT);
            }
        }

        @Override
        public boolean onApplyEnter(PvPControl c, long roleId, int gotoType) {
            return c.doApplyEnter(roleId, gotoType);
        }

        @Override
        public void onApplyLeave(PvPControl c, long roleId) {
            c.doApplyLeave(roleId);
        }
    }

    public static class Start
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.START;
        }

        @Override
        public void onEnter(PvPControl c) {
            c.createNpc();
            c.changeStage(EPvPStage.PREPARE);
        }

        @Override
        public void onLeave(PvPControl c) {
        }
    }

    public static class NotOpen
    implements IPvPStage {
        @Override
        public final EPvPStage getStage() {
            return EPvPStage.NOTOPEN;
        }

        @Override
        public void onEnter(PvPControl c) {
        }

        @Override
        public void onLeave(PvPControl c) {
        }
    }
}

